<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 9: The C Preprocessor</title>
<link href="sx8.html" rev=precedes>
<link href="sx9a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 9: The C Preprocessor</H1>

<p>Conceptually, the ``preprocessor'' is a translation 
phase that is applied to your source code before the compiler 
proper gets its hands on it.
(Once upon a time, the preprocessor was a separate program, 
much as the compiler and linker may still be separate programs 
today.)
Generally, the preprocessor performs textual substitutions on 
your source code,
in three sorts of ways:
<UL><li>File inclusion:
inserting the contents of another file into your source file,
as if you had typed it all in there.
<li>Macro substitution:
replacing instances of one piece of text with another.
<li>Conditional compilation:
Arranging that, depending on various circumstances,
certain parts of your source code are seen or not seen by the 
compiler at all.
</UL>The next three sections will introduce these three 
preprocessing functions.
</p><p>The syntax of the preprocessor is different from the syntax of 
the rest of C in several respects.
First of all, the preprocessor is ``line based.''
Each of the preprocessor directives we're going to learn about 
(all of which begin with the <TT>#</TT> character)
must begin at the beginning of a line,
and
each
ends at the end of the line.

(The rest of C treats line ends as just another whitespace
character,
and doesn't care how your program text is arranged into lines.)
Secondly, the preprocessor does not know about the structure of 
C--about
functions, statements, or expressions.
It is possible to play strange tricks with the preprocessor to 
turn something which does not look like C into C (or vice versa).
It's also possible to run into problems when a preprocessor 
substitution does not do what you expected it to, because
the preprocessor
does not respect the structure of C statements and expressions
(but you expected it to).
For the simple uses of the preprocessor we'll be discussing,
you shouldn't have any of these problems,
but you'll want to be careful before doing anything tricky or 
outrageous with the preprocessor.
(As it happens, playing tricky and outrageous games with the 
preprocessor is considered sporting in some circles,
but it rapidly gets out of hand, and can lead to bewilderingly 
impenetrable programs.)
</p><p><a href="sx9a.html" rel=subdocument>9.1 File Inclusion</a></p>
<p><a href="sx9b.html" rel=subdocument>9.2 Macro Definition and Substitution</a></p>
<p><a href="sx9c.html" rel=subdocument>9.3 Conditional Compilation</a></p>
<hr>
<p>
Read sequentially:
<a href="sx8.html" rev=precedes>prev</a>
<a href="sx9a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
